import torch
import torch.nn as nn

class SimpleRNN(nn.Module):
    def __init__(self, input_size=18*18, hidden_size=256, num_layers=2, num_class=5, device='cuda', bias=0):
        super(SimpleRNN, self).__init__()
        self.hidden_size = hidden_size
        self.num_class = num_class
        self.rnn = nn.LSTM(input_size, hidden_size, num_layers, batch_first=True, dropout=0.05)
        self.classifier = nn.Linear(hidden_size, num_class, bias=True)
        self.device = device
        self.hidden = None
        self.weights = torch.tensor([[bias,0,0,0,0]])

    def forward(self, inputs):
        out, self.hidden = self.rnn(inputs.to('cpu').view(1, 1, -1).to(self.device), self.hidden)
        _, pred = torch.max(self.classifier(out[-1, :, :]).to('cpu') + self.weights, 1)

        return pred.to(self.device)






