import torch
import torchvision
import torchvision.models.resnet as resnet
import torch.nn as nn


model_path = '/data/Disk_A/pytracking/ltr/cycle_net.pth.tar'
model_state = torch.load(model_path, map_location='cpu')['state_dict']

net = resnet.resnet50()
#net = nn.Sequential(*list(net.children())[:-3])
net_state = net.state_dict()

for k in [k for k in model_state.keys() if 'encoderVideo' in k]:
    kk = k.replace('module.encoderVideo.', '')
    tmp = model_state[k]
    if net_state[kk].shape != model_state[k].shape and net_state[kk].dim() == 4 and model_state[k].dim() == 5:
        tmp = model_state[k].squeeze(2)
    net_state[kk][:] = tmp[:]

net.load_state_dict(net_state)


inp = torch.randn(1, 3, 240, 240)
out = net(inp)
print(out.size())