import importlib


class Tracker:
    def __init__(self, name: str, parameter_name: str):
        self.name = name
        self.parameter_name = parameter_name

        tracker_module = importlib.import_module('pytracking.tracker.{}'.format(self.name))

        self.parameters = self.get_parameters()
        self.tracker_class = tracker_module.get_tracker_class()

    def run_init(self):
        self.parameters.visualization = False
        self.parameters.debug = False

        tracker = self.tracker_class(self.parameters)
        tracker.initialize_network()

        return tracker

    def get_parameters(self):
        param_module = importlib.import_module('pytracking.parameter.{}.{}'.format(self.name, self.parameter_name))
        params = param_module.parameters()

        return params

    def run_vot_init(self, tracker, image, state):
        tracker.initialize(image, state)

        return tracker

